#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
  Prototypes for functions in the file USB_io.c
*/

int check_io ( int fd, int tmout, char *buf, int bufsize, int *bytes_read );
void close_port ( int fd );
int open_port ( char *port );
int send_line ( int fd, char *line, int n );

/* Time to wait for input from the port */

#define TMOUT 10

/*
  The main program starts here.
*/

main(int argc, char* argv[])
{
  int blen, c, fd, i, keep[10], n, res;
  char buf[255], line[255];
  char* DefaultPort = "/dev/ttyACM0";
  char* port;
  char* s;
/* 
  Open port for reading and writing.
*/

  if ( argc < 2 ) port = DefaultPort; else port = argv[1];
  printf("Opening %s\n", port);
  fd = open_port ( port );
  if ( fd < 0 ) exit(-1);

/*
  Read from the port until it says it doesn't have any more.
*/

  while ( check_io ( fd, TMOUT, buf, 255, &blen ) ) ;
  { if (blen>0) printf(buf);
  }

/*
  Loop until EOF or first character is 'z'.
*/

  while ( 1 ) {
    printf("Ready for more input: ");
    if ( gets(line) == NULL ) break;;
    if ( line[0] == 'z' ) break;
    c = strlen(line);
    line[c] = '\n';
    line[c+1] = '\r';
    line[c+2] = '\0';

/*
  Send the input to the port.
*/

    res = send_line(fd,line,c+2);
    if ( res < 0 ) break; /* send_line prints error message in this case */

/*
  Collect and print the reply from the port.
*/

    while ( check_io ( fd, TMOUT, buf, 255, &blen ) )
    { if (blen>0) printf(buf);
    }

  }

  close_port( fd );
}
