#include <sys/select.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>

int open_port ( char* port )
{ int fd;
  fd = open(port, O_RDWR | O_NOCTTY ); 
  if (fd <0) {perror(port); return -1; }
  return fd;
}

/* Check for available input from fd.  If input is
   ready, put the characters in buf.  Put the
   number of characters read in bytes_read.
*/

int check_io ( int fd, int tmout, char *buf, int bufsize, int *bytes_read )
{
  int n = 0, i;
  struct timeval tv;
  fd_set fds;

  tv.tv_sec = tmout / 1000;
  tv.tv_usec = (tmout % 1000) * 1000L;

  FD_ZERO(&fds);
  FD_SET(fd, &fds);

  if ( select(fd+1, &fds, NULL, NULL, &tv) > 0 )
    n = (FD_ISSET(fd, &fds) > 0);

  /* If there is data put it in the buffer. */
  i = 0;
  if ((n & 1) == 1) { i = read(fd, buf, bufsize - 1); }
  buf[i > 0 ? i : 0] = 0;
  *bytes_read = i;

  return n;
}

/* Send a line of n characters to the serial port. */

int send_line ( int fd, char *line, int n )
{ int res;
  res = write(fd,line,n);
  if ( res < 0 )
    fprintf(stderr, "Error while writing (res = %d)\n", res);
//tcdrain(fd); /* wait for the characters to be sent */
  return res;
}

void close_port ( int fd )
{
  close ( fd );
}
